;;; P[VAhX̐ݒ
	LOCATE	0x20000000

;;; V{̒`
GPIO_BASE_ADDR_H	EQU	0x8000			;GPIO Base Address High
GPIO_IN_OFFSET		EQU	0x0				;GPIO Input Port Register Offset
GPIO_OUT_OFFSET		EQU	0x4				;GPIO Output Port Register Offset

7SEG_DATA_0			EQU	0xC0
7SEG_DATA_1			EQU	0xF9
7SEG_DATA_2			EQU	0xA4
7SEG_DATA_3			EQU	0xB0
7SEG_DATA_4			EQU	0x99
7SEG_DATA_5			EQU	0x92
7SEG_DATA_6			EQU	0x82
7SEG_DATA_7			EQU	0xF8
7SEG_DATA_8			EQU	0x80
7SEG_DATA_9			EQU	0x90


	XORR	r0,r0,r0

;;; Tu[`R[̃R[WX^ɃZbg
	ORI		r0,r1,high(CONV_NUM_TO_7SEG_DATA)	;xCONV_NUM_TO_7SEG_DATȀ16rbgr1ɃZbg
	SHLLI	r1,r1,16
	ORI		r1,r1,low(CONV_NUM_TO_7SEG_DATA)	;xCONV_NUM_TO_7SEG_DATẢ16rbgr1ɃZbg

	ORI		r0,r2,high(SET_GPIO_OUT)			;xSET_GPIO_OUT̏16rbgr2ɃZbg
	SHLLI	r2,r2,16
	ORI		r2,r2,low(SET_GPIO_OUT)				;xSET_GPIO_OUT̏16rbgr2ɃZbg

	ORI		r0,r3,high(WAIT_PUSH_SW)			;xWAIT_PUSH_SW̏16rbgr3ɃZbg
	SHLLI	r3,r3,16
	ORI		r3,r3,low(WAIT_PUSH_SW)				;xWAIT_PUSH_SW̏16rbgr3ɃZbg

;;; JE^[̒l
_COUNTER_RESET:
	ORI		r0,r4,0

_7SEG_COUNTER_LOOP:
;;; 7ZO_
	ORR		r0,r4,r16					;JE^[̒lɃZbg
	CALL	r1							;CONV_NUM_TO_7SEG_DATAĂяo
	ANDR	r0,r0,r0					;NOP

	ORR		r0,r17,r16					;o̓f[^ɃZbg
	CALL	r2							;SET_GPIO_OUTĂяo
	ANDR	r0,r0,r0					;NOP

	CALL	r3							;WAIT_PUSH_SWĂяo
	ANDR	r0,r0,r0					;NOP

_COUNT_UP:
	ADDUI	r4,r4,1
	ORI		r0,r5,100
	BE		r5,r4,_COUNTER_RESET
	ANDR	r0,r0,r0					;NOP
	BE		r0,r0,_7SEG_COUNTER_LOOP
	ANDR	r0,r0,r0					;NOP


CONV_NUM_TO_7SEG_DATA:
	;; ʂ̌琔𒊏o
	ORR		r0,r16,r18					;r16r18ɃRs[
	XORR	r17,r17,r17					;Return ValuẽNA
	XORR	r19,r19,r19					;0:1(7SEG2), 1:2(7SEG1)
	XORR	r20,r20,r20					;2ڂ̒l
	;; 10̈ʂ̒l߂
	ORI		r0,r21,10					;r2110
_SUB10:
	BUGT	r18,r21,_CHECK_0			;r18<r21(r18<10)Ȃ_CHECK_0ɂƂ
	ANDR	r0,r0,r0					;NOP
	ADDUI	r18,r18,-10
	ADDUI	r20,r20,1
	BE		r0,r0,_SUB10				;r21<r18ȂSUB10ɂƂ
	ANDR	r0,r0,r0					;NOP

_CHECK_0:
	ORI		r0,r21,0
	BNE		r18,r21,_CHECK_1
	ANDR	r0,r0,r0					;NOP
	ORI		r0,r22,7SEG_DATA_0
	BNE		r0,r19,_SET_RETURN_VALUE
	ANDR	r0,r0,r0					;NOP
	SHLLI	r22,r22,8					;7SEG2p8rbgVtg
	BE		r0,r0,_SET_RETURN_VALUE
	ANDR	r0,r0,r0					;NOP

_CHECK_1:
	ORI		r0,r21,1
	BNE		r18,r21,_CHECK_2
	ANDR	r0,r0,r0					;NOP
	ORI		r0,r22,7SEG_DATA_1
	BNE		r0,r19,_SET_RETURN_VALUE
	ANDR	r0,r0,r0					;NOP
	SHLLI	r22,r22,8					;7SEG2p8rbgVtg
	BE		r0,r0,_SET_RETURN_VALUE
	ANDR	r0,r0,r0					;NOP

_CHECK_2:
	ORI		r0,r21,2
	BNE		r18,r21,_CHECK_3
	ANDR	r0,r0,r0					;NOP
	ORI		r0,r22,7SEG_DATA_2
	BNE		r0,r19,_SET_RETURN_VALUE
	ANDR	r0,r0,r0					;NOP
	SHLLI	r22,r22,8					;7SEG2p8rbgVtg
	BE		r0,r0,_SET_RETURN_VALUE
	ANDR	r0,r0,r0					;NOP

_CHECK_3:
	ORI		r0,r21,3
	BNE		r18,r21,_CHECK_4
	ANDR	r0,r0,r0					;NOP
	ORI		r0,r22,7SEG_DATA_3
	BNE		r0,r19,_SET_RETURN_VALUE
	ANDR	r0,r0,r0					;NOP
	SHLLI	r22,r22,8					;7SEG2p8rbgVtg
	BE		r0,r0,_SET_RETURN_VALUE
	ANDR	r0,r0,r0					;NOP

_CHECK_4:
	ORI		r0,r21,4
	BNE		r18,r21,_CHECK_5
	ANDR	r0,r0,r0					;NOP
	ORI		r0,r22,7SEG_DATA_4
	BNE		r0,r19,_SET_RETURN_VALUE
	ANDR	r0,r0,r0					;NOP
	SHLLI	r22,r22,8					;7SEG2p8rbgVtg
	BE		r0,r0,_SET_RETURN_VALUE
	ANDR	r0,r0,r0					;NOP

_CHECK_5:
	ORI		r0,r21,5
	BNE		r18,r21,_CHECK_6
	ANDR	r0,r0,r0					;NOP
	ORI		r0,r22,7SEG_DATA_5
	BNE		r0,r19,_SET_RETURN_VALUE
	ANDR	r0,r0,r0					;NOP
	SHLLI	r22,r22,8					;7SEG2p8rbgVtg
	BE		r0,r0,_SET_RETURN_VALUE
	ANDR	r0,r0,r0					;NOP

_CHECK_6:
	ORI		r0,r21,6
	BNE		r18,r21,_CHECK_7
	ANDR	r0,r0,r0					;NOP
	ORI		r0,r22,7SEG_DATA_6
	BNE		r0,r19,_SET_RETURN_VALUE
	ANDR	r0,r0,r0					;NOP
	SHLLI	r22,r22,8					;7SEG2p8rbgVtg
	BE		r0,r0,_SET_RETURN_VALUE
	ANDR	r0,r0,r0					;NOP

_CHECK_7:
	ORI		r0,r21,7
	BNE		r18,r21,_CHECK_8
	ANDR	r0,r0,r0					;NOP
	ORI		r0,r22,7SEG_DATA_7
	BNE		r0,r19,_SET_RETURN_VALUE
	ANDR	r0,r0,r0					;NOP
	SHLLI	r22,r22,8					;7SEG2p8rbgVtg
	BE		r0,r0,_SET_RETURN_VALUE
	ANDR	r0,r0,r0					;NOP

_CHECK_8:
	ORI		r0,r21,8
	BNE		r18,r21,_CHECK_9
	ANDR	r0,r0,r0					;NOP
	ORI		r0,r22,7SEG_DATA_8
	BNE		r0,r19,_SET_RETURN_VALUE
	ANDR	r0,r0,r0					;NOP
	SHLLI	r22,r22,8					;7SEG2p8rbgVtg
	BE		r0,r0,_SET_RETURN_VALUE
	ANDR	r0,r0,r0					;NOP

_CHECK_9:
	ORI		r0,r22,7SEG_DATA_9
	BNE		r0,r19,_SET_RETURN_VALUE
	ANDR	r0,r0,r0					;NOP
	SHLLI	r22,r22,8					;7SEG2p8rbgVtg

_SET_RETURN_VALUE:
	ORR		r17,r22,r17
	BNE		r0,r19,_CONV_NUM_TO_7SEG_DATA_RETURN
	ANDR	r0,r0,r0					;NOP
_NEXT_DIGIT:
	ORR		r0,r20,r18
	ORI		r19,r19,1					;0:1(7SEG2), 1:2(7SEG1)
	BE		r0,r0,_CHECK_0
	ANDR	r0,r0,r0					;NOP
_CONV_NUM_TO_7SEG_DATA_RETURN:
	JMP		r31
	ANDR	r0,r0,r0					;NOP


SET_GPIO_OUT:
	ORI		r0,r17,GPIO_BASE_ADDR_H
	SHLLI	r17,r17,16
	STW		r17,r16,GPIO_OUT_OFFSET
_SET_GPIO_OUT_RETURN:
	JMP		r31
	ANDR	r0,r0,r0					;NOP


WAIT_PUSH_SW:
	ORI		r0,r16,GPIO_BASE_ADDR_H
	SHLLI	r16,r16,16
_WAIT_PUSH_SW_ON:
	LDW		r16,r17,GPIO_IN_OFFSET
	BE		r0,r17,_WAIT_PUSH_SW_ON
	ANDR	r0,r0,r0					;NOP
_WAIT_PUSH_SW_OFF:
	LDW		r16,r17,GPIO_IN_OFFSET
	BNE		r0,r17,_WAIT_PUSH_SW_OFF
	ANDR	r0,r0,r0					;NOP
_WAIT_PUSH_SW_RETURN:
	JMP		r31
	ANDR	r0,r0,r0					;NOP
