;;; P[VAhX̐ݒ
	LOCATE	0x20000000

;;; V{̒`
UART_BASE_ADDR_H		EQU	0x6000		;UART Base Address High
UART_STATUS_OFFSET		EQU	0x0			;UART Status Register Offset
UART_DATA_OFFSET		EQU	0x4			;UART Data Register Offset
UART_RX_INTR_MASK		EQU	0x1			;UART Receive Interrupt Mask
UART_TX_INTR_MASK		EQU	0x2			;UART Transmit Interrupt Mask
GPIO_BASE_ADDR_H		EQU	0x8000		;GPIO Base Address High
GPIO_OUT_OFFSET			EQU	0x4			;GPIO Data Register Offset


	XORR	r0,r0,r0					;r00NA

	ORI		r0,r1,high(CLEAR_BUFFER)	;CLEAR_BUFFEȐ16rbgr1ɃZbg
	SHLLI	r1,r1,16
	ORI		r1,r1,low(CLEAR_BUFFER)		;CLEAR_BUFFER̉16rbgr1ɃZbg

	ORI		r0,r2,high(SEND_CHAR)		;SEND_CHAȐ16rbgr2ɃZbg
	SHLLI	r2,r2,16
	ORI		r2,r2,low(SEND_CHAR)		;SEND_CHAR̉16rbgr2ɃZbg

	ORI		r0,r3,high(SET_GPIO_OUT)	;SET_GPIO_OUT̏16rbgr3ɃZbg
	SHLLI	r3,r3,16
	ORI		r3,r3,low(SET_GPIO_OUT)		;SET_GPIO_OUT̉16rbgr3ɃZbg


;;; OxN^̐ݒ
	ORI		r0,r4,high(EXCEPT_HANDLER)
	SHLLI	r4,r4,16
	ORI		r4,r4,low(EXCEPT_HANDLER)
	WRCR	r4,c4

;;; UARTobt@NA
	CALL	r1							;CLEAR_BUFFERĂяo
	ANDR	r0,r0,r0					;NOP

;;; ZpI[o[t[𔭐
	ORI		r0,r4,0x7FFF
	SHLLI	r4,r4,16
	ORI		r4,r4,0xFFFF
	ADDSI	r4,r4,1

;;; LED_
	ORI		r0,r16,0x2
	SHLLI	r16,r16,16
	ORI		r16,r16,0xFFFF				;o̓f[^r16ɃZbg
	CALL	r3
	ANDR	r0,r0,r0					;NOP

;; [v
LOOP:
	BE		r0,r0,LOOP					;[v
	ANDR	r0,r0,r0					;NOP


CLEAR_BUFFER:
	ORI		r0,r16,UART_BASE_ADDR_H		;UART Base Address16rbgr2ɃZbg
	SHLLI	r16,r16,16

_CHECK_UART_STATUS:
	LDW		r16,r17,UART_STATUS_OFFSET	;STATUS擾

	ANDI	r17,r17,UART_RX_INTR_MASK
	BE		r0,r17,_CLEAR_BUFFER_RETURN	;Receive Interrupt bitĂȂ_CLEAR_BUFFER_RETURNs
	ANDR	r0,r0,r0					;NOP

_RECEIVE_DATA:
	LDW		r16,r17,UART_DATA_OFFSET	;Mf[^ǂŃobt@NA

	LDW		r16,r17,UART_STATUS_OFFSET	;STATUS擾
	XORI	r17,r17,UART_RX_INTR_MASK
	STW		r16,r17,UART_STATUS_OFFSET	;Receive Interrupt bitNA

	BNE		r0,r0,_CHECK_UART_STATUS	;_CHECK_UART_STATUSɖ߂
	ANDR	r0,r0,r0					;NOP
_CLEAR_BUFFER_RETURN:
	JMP		r31							;Ăяoɖ߂
	ANDR	r0,r0,r0					;NOP


SEND_CHAR:
	ORI		r0,r17,UART_BASE_ADDR_H		;UART Base Address16rbgr17ɃZbg
	SHLLI	r17,r17,16
	STW		r17,r16,UART_DATA_OFFSET	;r16𑗐M

_WAIT_SEND_DONE:
	LDW		r17,r18,UART_STATUS_OFFSET	;STATUS擾
	ANDI	r18,r18,UART_TX_INTR_MASK
	BE		r0,r18,_WAIT_SEND_DONE
	ANDR	r0,r0,r0

	LDW		r17,r18,UART_STATUS_OFFSET
	XORI	r18,r18,UART_TX_INTR_MASK
	STW		r17,r18,UART_STATUS_OFFSET	;Transmit Interrupt bitNA

	JMP		r31							;Ăяoɖ߂
	ANDR	r0,r0,r0					;NOP

SET_GPIO_OUT:
	ORI		r0,r17,GPIO_BASE_ADDR_H
	SHLLI	r17,r17,16
	STW		r17,r16,GPIO_OUT_OFFSET
_SET_GPIO_OUT_RETURN:
	JMP		r31
	ANDR	r0,r0,r0					;NOP


;;; Onh
;; OR[hVAɕ\
EXCEPT_HANDLER:
	RDCR	c5,r24
	ANDI	r24,r24,0x7

	ADDUI	r24,r24,48

	ORR		r0,r24,r16
	CALL	r2							;SEND_CHARĂяo
	ANDR	r0,r0,r0					;NOP

;;; LED_
	ORI		r0,r16,0x1
	SHLLI	r16,r16,16
	ORI		r16,r16,0xFFFF				;o̓f[^r16ɃZbg
	CALL	r3
	ANDR	r0,r0,r0					;NOP

;;; [v
EXCEPT_LOOP:
	BE		r0,r0,EXCEPT_LOOP			;[v
	ANDR	r0,r0,r0					;NOP
